diff --git a/src/mux_h1.c b/src/mux_h1.c
index 60fa59fcd639..426e9966bbdb 100644
--- a/src/mux_h1.c
+++ b/src/mux_h1.c
@@ -2212,7 +2212,8 @@ static int h1_process(struct h1c * h1c)
 	if (!h1s_data_pending(h1s) && h1s && h1s->cs && h1s->cs->data_cb->wake &&
 	    (h1s->flags & H1S_F_REOS || h1c->flags & H1C_F_CS_ERROR ||
 	    conn->flags & (CO_FL_ERROR | CO_FL_SOCK_WR_SH))) {
-		if (h1c->flags & H1C_F_CS_ERROR || ((conn->flags & CO_FL_ERROR) && !b_data(&h1c->ibuf)))
+		if (h1c->flags & H1C_F_CS_ERROR || ((conn->flags & CO_FL_ERROR) &&
+		     ((h1s->cs->flags & (CS_FL_EOI|CS_FL_EOS)) || !b_data(&h1c->ibuf))))
 			h1s->cs->flags |= CS_FL_ERROR;
 		h1s->cs->data_cb->wake(h1s->cs);
 	}
@@ -2618,7 +2619,8 @@ static size_t h1_snd_buf(struct conn_stream *cs, struct buffer *buf, size_t coun
 			break;
 	}
 
-	if (h1c->flags & H1C_F_CS_ERROR || ((h1c->conn->flags & CO_FL_ERROR) && !b_data(&h1c->ibuf)))
+	if (h1c->flags & H1C_F_CS_ERROR || ((h1c->conn->flags & CO_FL_ERROR) &&
+	     ((cs->flags & (CS_FL_EOI|CS_FL_EOS)) || !b_data(&h1c->ibuf))))
 		cs->flags |= CS_FL_ERROR;
 
 	h1_refresh_timeout(h1c);
